import datetime
from odoo import models
from odoo.exceptions import AccessError
from odoo.addons.saas_worker.const import SPECIAL_PREFIXES
from odoo.addons.saas_worker import metabase
from odoo.tools.translate import _

class IrDemo(models.TransientModel):

    _inherit = 'ir.demo'

    def install_demo(self):
        db = metabase.get(self._cr.dbname)
        if db and (db.create_date >= datetime.datetime.now() - datetime.timedelta(hours=4) or db.name.startswith(SPECIAL_PREFIXES)):
            with metabase.disable_email_limit(self._cr.dbname):
                return super(IrDemo, self).install_demo()
        else:
            raise AccessError(_("Demo data can only be installed on demo databases (name starts with 'demo-') or on databases created less than 4 hours ago."))
